//Näidisprogramm ainele Programmeerimiskeeled
//Autor Uku Raudvere
//Tugevasti inspireeritud Go abidokumentidest

package main

import ("fmt")

type binIntFunc func(a, b int) int

type Päring struct{
    a, b int
    f binIntFunc
    vastusc chan int
}

func liida(a, b int) int {return a + b}
func korruta(a, b int) int {return a * b}

func käivita(päring *Päring){
    päring.vastusc <- päring.f(päring.a, päring.b)
}

func server(päringukanal chan *Päring){
    for {
        päring := <- päringukanal
        go käivita(päring)
    }
}

func KäivitaServer() chan *Päring{
    päringukanal := make(chan *Päring)
    go server(päringukanal)
    return päringukanal
}

func main(){
    server := KäivitaServer()
    p1 := &Päring{10, 17, korruta, make(chan int)}
    p2 := &Päring{10, 17, liida, make(chan int)}
    p3 := &Päring{10, 17, func(a, b int) int {return a - b}, make(chan int)}
    
    server <- p1;
    server <- p2;
    server <- p3;

    //vastused saame suvalises järjekorras
    v2 := <- p2.vastusc   
    v1 := <- p1.vastusc
    v3 := <- p3.vastusc

    fmt.Println(v1)
    fmt.Println(v2)
    fmt.Println(v3)
    
}
